

[data,header] = xlsread(file_name);
[nobs,ncol] = size(data);
[nrow_header, ncol_header] = size(header);

header = header(1,ncol_header-ncol+1:end);


if isempty(X_str)
    disp('Regressors in VAR are not specified. For illustration, all the data in the EXCEL file is used as regressors')
    for m = 1:ncol
        X_str = [X_str,' ',header{m}];
    end
end


X_str = strtrim(X_str);
header = strtrim(header);
X_str = strrep(X_str, '	',' ');
X_str = strrep(X_str, '',' ');
X_str = strrep(X_str, ',',' ');
X_str = strrep(X_str, ';',' ');
for m = 1:5
    X_str = strrep(X_str, '  ',' ');
end
X_str = strrep(X_str, ' (','(');
X_str = strrep(X_str, '( ','(');
X_str = strrep(X_str, ' )',')');
X_str = strrep(X_str, ' -','-');
X_str = strrep(X_str, '- ','-');


sep = strfind(X_str,' ');
sep = [0,sep,length(X_str)+1];
nvar = length(sep) - 1;
X = NaN(nobs,nvar);
for m = 1:nvar  
    var_use = X_str(sep(m)+1:sep(m+1)-1);    
    if strcmp(var_use(end),')')
        bracket_left = strfind(var_use,'(');
        bracket_right = strfind(var_use,')');
        var_mask = strcmpi(header, var_use(1:bracket_left-1));
        try
            nlag = str2double(var_use(bracket_left+2:bracket_right-1));
        catch
            error('Ooopse, Incorrect format of the lagged variable.')
        end
    else
        var_mask = strcmpi(header, var_use);
        nlag = 0;
    end
    
    switch sum(var_mask)
        case 0
            error(['Ooopse, The regressor ',var_use, ' is not found in the EXCEL data'])
        case 1
            disp(['The regressor ',var_use, ' is successfully identified.'])
            X(nlag+1:end,m) = data(nlag+1:end,var_mask);
        otherwise
            error(['Ooopse, The regressor ',var_use, ' is found multiple times in the EXCEL data'])
    end
         
end


switch model_flag
    case 0
        VARDAS1(X,nlag_VAR,sum_flag,add_constant,ndraws,burn_in);
    case 1
        VARDAS1(X,nlag_VAR,sum_flag,add_constant,ndraws,burn_in);
    case 2
        VARDAS2(X,nlag_VAR,sum_flag,add_constant,ndraws,burn_in);
    case 3
        VARDAS3(X,nlag_VAR,sum_flag,[],add_constant,ndraws,burn_in);
    case 4
        VARDAS4(X,nlag_VAR,sum_flag,add_constant,ndraws,burn_in);    
end
